> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoycore/object-model/database-server/table/method.md).

# Method

Reference documentation for a Method object

## Overview

A **Method** is a way of adding custom logic to entities. It can also be used to handle table/entity events. It can be created directly in the entity file from *"methods"* tab or through *"events"* (table, forms, etc.).\
Entity scopes are the foundset scopes to give a foundset extra functionality. They should be used if there are business rules that are based on table/data, really belong to that datasource, so it is just a narrower scope then what named global scope would be.

## File Structure

The code for a Method is stored in a script file in a [Solution](/reference/servoy-developer/project-file-structure/workspace-folder/solution-folder.md) directory -> "datasources" directory -> "table-name" directory. The file has the same name as the table followed by "\_entity", with a `.js` extension. For example, the `orders` table would have the methods file `orders_entity.js`.\
Nesting file path: "solution/datasources/server-name/table-name/table-name\_entity.js"

## Properties Summary

The following properties can be set for Method:

| Property          | Summary                                                 |
| ----------------- | ------------------------------------------------------- |
| [Name](#name)     | The name of the method                                  |
| [Source](#source) | This is the JavaScipt function that defines the method. |

## Properties Details

### Name

The name of the method. It is also the same name as the function.

### Source

This is the JavaScript function that defines the method. Other data providers from this table, related data sources and scope variables can be used.

**Example**

Let's consider *"administration"* table, part of *"exampleData"* database server and a method defined in table entity scope:

```javascript
/**
 * @properties={typeid:24,uuid:"A2F01DCA-0BFB-4045-AF3C-9472064C5D5F"}
 */
function getDefaultAdministration()
{
	if (find()) {
		is_default = 1;

		if (search()) {
			return getRecord(1);
		}
	}
	
	return null;
}
```

The method can be called in solution or forms' scopes, **always related to the same foundset the method is defined for**: "datasources.db.server-name-table-name.getFoundset().EntityMethodName()"

```javascript
	var adminRecord = datasources.db.exampleData.administration.getFoundset().getCurrentAdministration();
```

The method can also be linked to a [table event](/reference/servoycore/object-model/database-server/table.md#events-details) or [form event](/reference/servoycore/object-model/database-server/table/method.md).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/servoycore/object-model/database-server/table/method.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
